<?php
// Require libraries needed for gateway module functions.
require_once __DIR__ . '/../../../init.php';
require_once __DIR__ . '/../../../includes/gatewayfunctions.php';
require_once __DIR__ . '/../../../includes/invoicefunctions.php';

// Detect module name from filename.
$gatewayModuleName = basename(__FILE__, '.php');

// Fetch gateway configuration parameters.
$gatewayParams = getGatewayVariables($gatewayModuleName);

// Die if module is not active.
if (!$gatewayParams['type']) {
    die("Module Not Activated");
}

// Retrieve data returned in payment gateway callback
// Varies per payment gateway
$service_code = $_REQUEST['service_code'];
$customer_account_id = $_REQUEST['customer_account_id'];
$customer_email = $_REQUEST['customer_email'];
$transaction_date = $_REQUEST['transaction_date'];
$transaction_reference = $_REQUEST['transaction_reference'];
$amount = $_REQUEST['transaction_value'];
$description = $_REQUEST['description'];
$session_id = $_REQUEST['session_id'];
	
$invoiceId = $_REQUEST["invoiceId"];
$transactionId = $transaction_reference;
$paymentFee =0;

$transactionStatus = 'Failure';
$success = false;

$apiKey = $gatewayParams['apiKey'];
$apiToken = $gatewayParams['apiToken'];

if(!empty($transaction_reference)) {
    //validate
    $ch = curl_init();
	curl_setopt($ch,CURLOPT_URL,"https://api.ufitpay.com/v1/verify_payment");
	curl_setopt($ch,CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS,   http_build_query(array('transaction_reference' => $transaction_reference)));
	curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch,CURLOPT_SSL_VERIFYPEER, false);
	$headers = array (
		'Api-Token: '.$apiToken,
		'Api-Key: '.$apiKey,
		'content-type: application/x-www-form-urlencoded'
	);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	$server_output = curl_exec ($ch);
	curl_close($ch);
	
	$data = json_decode($server_output,true);
	if($data['status'] =="success") {
	    $datas = $data['data'];
	    $payment_status = $datas['status'];
	    $paymentAmount = $payment_amount = $datas['transaction_value']; 
	    $payment_service = $datas['service_code'];
	    $credit_account_number = $datas['credit_account_number'];
	    $online_reference = $datas['session_id'];
	    $request_ref = $datas['request_ref'];
	    if($payment_status=="completed" && $payment_amount > 0 ) {
	        //check payment type
	        if($payment_service == "bank_deposit") {
           		    if($payment_amount >= $amount_converted) {
							$transactionStatus =  'Success';
							$success = true;
           		    }
	        }
	    } 
	} 
}	
	
//Check if invoice still exist
$invoiceId = checkCbInvoiceID($invoiceId, $gatewayParams['name']);

//Check of transaction ID has been used before
checkCbTransID($transactionId);

logTransaction($gatewayParams['name'], $_POST, $transactionStatus);

if ($success) {
    addInvoicePayment(
        $invoiceId,
        $transactionId,
        $paymentAmount,
        $paymentFee,
        $gatewayModuleName
    );
}